#include <stdio.h>
#include <stdlib.h>

#ifdef __TOS__
#include <aes.h>
#include <vdi.h>
#define M_DOT 1
#define M_PLUS 2
#define M_ASTERISK 3
#define M_SQUARE 4
#define M_CROSS 5
#define M_DIAMOND 6

#define CLIP_OFF 0
#define CLIP_ON 1
#else
#include "ovdisis/ovdi_more.h"
#include "vdibind/vdibind.h"

VDIPARBLK e_vdiparblk;
VDIPB o_vdipb;          /* Must have this name when using vdibind!!! */
#endif /* __TOS__ */

int do_stuff(void);

/* Hmm, nice main() */
int main()
{
  do_stuff();
  return 0;
}

int do_stuff()
{
#ifndef __TOS__
  char ch;
#endif /* __TOS__ */
  int i,vp1,vh1,vh2,pxy[16];
  int work_in[11] = { 1,1,1,1,1,1,1,1,1,1,2 };
  int work_out[57];

#ifndef __TOS__
  /* initialize o_vdipb */
  o_vdipb.contrl=e_vdiparblk.contrl;
  o_vdipb.intin=e_vdiparblk.intin;
  o_vdipb.ptsin=e_vdiparblk.ptsin; 
  o_vdipb.intout=e_vdiparblk.intout; 
  o_vdipb.ptsout=e_vdiparblk.ptsout;
#endif /* __TOS__ */


#ifdef __TOS__
  vp1 = graf_handle(&i,&i,&i,&i);
#else
  /* Open physical workstation */
  v_opnwk(work_in, &vp1, work_out);
  if(!vp1)
    return 0;
#endif /* __TOS__ */


  vh1 = vp1;
  v_opnvwk(work_in, &vh1, work_out);
  if(!vh1)
    return 0;

  vsm_color(vh1, 1);
  vsm_height(vh1, 90);
  vsm_type(vh1, M_DOT);
  pxy[0] = 100;
  pxy[1] = 100;
  v_pmarker(vh1, 1, pxy);
  
  vh2 = vp1;
  v_opnvwk(work_in, &vh2, work_out);
  if(!vh2)
    return 0;

  vsm_height(vh2, 50);
  vsm_color(vh2, 2);
  vsm_type(vh2, M_PLUS);
  pxy[0] = 150;
  pxy[1] = 150;
  v_pmarker(vh2, 1, pxy);


  vsl_color(vh2, 2);
  pxy[0] = 350;
  pxy[1] = 50;
  pxy[2] = 600;
  pxy[3] = 130;
  pxy[4] = 400;
  pxy[5] = 400;
  pxy[6] = 50;
  pxy[7] = 100;
  v_pline(vh2, 4, pxy);


 
  pxy[0] = 105;
  pxy[1] = 105;
  pxy[2] = 480;
  pxy[3] = 310;
  vs_clip(vh2, CLIP_ON, pxy);
  
  vsl_color(vh2, 1);
  pxy[0] = 105;
  pxy[1] = 105;
  pxy[2] = 480;
  pxy[3] = 105;
  pxy[4] = 480;
  pxy[5] = 310;
  pxy[6] = 105;
  pxy[7] = 310;
  pxy[8] = 105;
  pxy[9] = 105;
  v_pline(vh2, 5, pxy);

  vsm_type(vh1, M_CROSS);
  pxy[0] = 300;
  pxy[1] = 200;
  v_pmarker(vh1, 1, pxy);
  
  vsm_type(vh2, M_DIAMOND);
  pxy[0] = 100;
  pxy[1] = 100;
  v_pmarker(vh2, 1, pxy);

  vsm_color(vh2, 5);
  vsm_type(vh2, M_SQUARE);
  pxy[0] = 400;
  pxy[1] = 300;
  v_pmarker(vh2, 1, pxy);

  vsm_color(vh1, 2);
  vsm_type(vh1, M_ASTERISK);
  pxy[0] = 500;
  pxy[1] = 200;
  v_pmarker(vh1, 1, pxy);


  pxy[0] = 460;
  pxy[1] = 170;
  pxy[2] = 530;
  pxy[3] = 220;
  vs_clip(vh1, CLIP_ON, pxy);
  
  pxy[0] = 460;
  pxy[1] = 170;
  pxy[2] = 530;
  pxy[3] = 170;
  pxy[4] = 530;
  pxy[5] = 220;
  pxy[6] = 460;
  pxy[7] = 220;
  pxy[8] = 460;
  pxy[9] = 170;
  v_pline(vh1, 5, pxy);


  vsm_color(vh1, 7);
  vsm_type(vh1, M_ASTERISK);
  pxy[0] = 500;
  pxy[1] = 200;
  v_pmarker(vh1, 1, pxy);

  vsl_color(vh2, 6);
  pxy[0] = 350;
  pxy[1] = 50;
  pxy[2] = 600;
  pxy[3] = 130;
  pxy[4] = 400;
  pxy[5] = 400;
  pxy[6] = 50;
  pxy[7] = 100;
  v_pline(vh2, 4, pxy);

  vs_clip(vh2, CLIP_OFF, pxy);

  vsl_color(vh2, 8);
  pxy[0] = 0;
  pxy[1] = 0;
  pxy[2] = work_out[0];
  pxy[3] = work_out[1];
  v_pline(vh2, 2, pxy);

  for(i=0 ; i<128 ; i++)
    {
      pxy[4] = 50 + (pxy[0] = 0);
      pxy[6] = 50 + (pxy[2] = 30);
      pxy[5] = pxy[7] = pxy[1] = pxy[3] = i*4+10;
      vsl_color(vh2, i);
      v_pline(vh2, 2, pxy);
      pxy[1]++; pxy[3]++;
      v_pline(vh2, 2, pxy);

      vsl_color(vh2, i+128);
      v_pline(vh2, 2, &pxy[4]);
      pxy[5]++; pxy[7]++;
      v_pline(vh2, 2, &pxy[4]);

    }
  /*
  for(i=0 ; i<16 ; i++)
    {
      int pvalue,pcol;

      v_get_pixel(vh2, 15, i*4+10, &pvalue, &pcol);
      printf("otestis: v_get_pixel %d,%d Value: %d Color %d\n",15,i*4+10,pvalue,pcol);
    }
   */

#ifdef __TOS__
  getchar();
#else
  while((ch=ovdi_getchar(vp1))!='s')
    putchar(ch);
#endif /* __TOS__ */

  pxy[0] = 1000;
  pxy[1] = 0;
  pxy[2] = 0;
  vs_color(vh2, 1, pxy);
  pxy[0] = 500;
  pxy[1] = 500;
  pxy[2] = 500;
  vs_color(vh2, 7, pxy);

  vq_color(vh2, 1, 0, pxy);
  vq_color(vh2, 7, 0, pxy);


#ifdef __TOS__
  getchar();
#else
  while((ch=ovdi_getchar(vp1))!='a')
    putchar(ch);
#endif /* __TOS__ */

  
  v_clsvwk(vh1);
  v_clsvwk(vh2);


#ifndef __TOS__
  v_clswk(vp1);
#endif /* __TOS__ */


  return 1;
}


