#include <stdio.h>

#include "ovdisis.h"


static void vdi_v_bar(VDI_Workstation *);
static void vdi_v_arc(VDI_Workstation *);
static void vdi_v_pieslice(VDI_Workstation *);
static void vdi_v_circle(VDI_Workstation *);
static void vdi_v_ellipse(VDI_Workstation *);
static void vdi_v_ellarc(VDI_Workstation *);
static void vdi_v_ellpie(VDI_Workstation *);
static void vdi_v_rbox(VDI_Workstation *);
static void vdi_v_rfbox(VDI_Workstation *);
static void vdi_v_justified(VDI_Workstation *);


VdiFunction *vdi_gdpfuncs[] = {
  UNUSED, vdi_v_bar, vdi_v_arc, vdi_v_pieslice, vdi_v_circle, vdi_v_ellipse,
  vdi_v_ellarc, vdi_v_ellpie, vdi_v_rbox, vdi_v_rfbox, vdi_v_justified
};


void vdi_gdps(VDI_Workstation *vwk)
{
  /* Check if specified subroutine is listed in vwk->cangdps[] */

  if(vdi_gdpfuncs[vdipb->contrl[SUBROUTINE]] && 
     (vdipb->contrl[SUBROUTINE] <= 10) && (vdipb->contrl[SUBROUTINE] >= 0))
    vdi_gdpfuncs[vdipb->contrl[SUBROUTINE]](vwk);
  else
    EDEBUG("vdi_gdps: Subroutine %d doesn't exist!\n",vdipb->contrl[SUBROUTINE]);
}


void vdi_v_bar(VDI_Workstation *vwk)
{
  EDEBUG("v_bar: Call not implemented!\n");
}

void vdi_v_arc(VDI_Workstation *vwk)
{
  EDEBUG("v_arc: Call not implemented!\n");
}

void vdi_v_pieslice(VDI_Workstation *vwk)
{
  EDEBUG("v_pieslice: Call not implemented!\n");
}

void vdi_v_circle(VDI_Workstation *vwk)
{
  EDEBUG("v_circle: Call not implemented!\n");
}

void vdi_v_ellipse(VDI_Workstation *vwk)
{
  EDEBUG("v_ellipse: Call not implemented!\n");
}

void vdi_v_ellarc(VDI_Workstation *vwk)
{
  EDEBUG("v_ellarc: Call not implemented!\n");
}

void vdi_v_ellpie(VDI_Workstation *vwk)
{
  EDEBUG("v_ellpie: Call not implemented!\n");
}

void vdi_v_rbox(VDI_Workstation *vwk)
{
  EDEBUG("v_rbox: Call not implemented!\n");
}

void vdi_v_rfbox(VDI_Workstation *vwk)
{
  EDEBUG("v_rfbox: Call not implemented!\n");
}

void vdi_v_justified(VDI_Workstation *vwk)
{
  EDEBUG("v_justified: Call not implemented!\n");
}


